// THIS FILE IS GENERATED AUTOMATICALLY. DO NOT MODIFY.
import { SigningStargateClient } from '@cosmjs/stargate'
import { Registry } from '@cosmjs/proto-signing'
import { Api } from './rest'
import { MsgSend } from './types/cosmos/bank/v1beta1/tx'
import { MsgMultiSend } from './types/cosmos/bank/v1beta1/tx'
const types = [
	['/cosmos.bank.v1beta1.MsgSend', MsgSend],
	['/cosmos.bank.v1beta1.MsgMultiSend', MsgMultiSend]
]
export const MissingWalletError = new Error('wallet is required')
const registry = new Registry(types)
const defaultFee = {
	amount: [],
	gas: '200000'
}
const txClient = async (
	wallet,
	{ addr: addr } = { addr: 'http://localhost:26657' }
) => {
	if (!wallet) throw MissingWalletError
	const client = await SigningStargateClient.connectWithSigner(addr, wallet, {
		registry
	})
	const { address } = (await wallet.getAccounts())[0]
	return {
		signAndBroadcast: (msgs, { fee, memo } = { fee: defaultFee, memo: '' }) =>
			client.signAndBroadcast(address, msgs, fee, memo),
		msgSend: (data) => ({
			typeUrl: '/cosmos.bank.v1beta1.MsgSend',
			value: data
		}),
		msgMultiSend: (data) => ({
			typeUrl: '/cosmos.bank.v1beta1.MsgMultiSend',
			value: data
		})
	}
}
const queryClient = async (
	{ addr: addr } = { addr: 'http://localhost:1317' }
) => {
	return new Api({ baseUrl: addr })
}
export { txClient, queryClient }
